# -*- coding: utf-8 -*-

import re, urllib
import base
import common

class DecorateUrls(base.Baselugin):
    def __init__(self,parent,modulename,active):
        base.Baselugin.__init__(self,parent,modulename,active)
        self.name = "Decorate URL`s"
        self.version = "v1.0"
        self.description = u"""Открывает ссылки в браузере по умолчанию."""
        self.active = active
        parent.Worker.parseImages = self.parseImages(parent.Worker.parseImages)

    def SetActive(self,active = True):
        self.active = active

    def insert_spaces(self,text):
        try:
            s = text.encode('ascii')
            s = urllib.unquote(s).decode('utf-8')
        except:
            s = text
        return re.sub('([^\s\n]{60})','\\1 ',s)

    def fix_long(self,m):
        if (m.group(1)=='www.'):
            href = "http://www."+m.group(3)
        else:
            href = m.group(1)+m.group(3)
        return '<glink href="%s" target="_blank">%s%s</glink>%s' % (href, m.group(1), self.insert_spaces(m.group(3)), m.group(4))

    def DecorateUrls(self,text):
        tpl = '(?i)((FTP|HTTP)://|www\.)(.*?)(\s|<|:|,\s|,<|,:|\.\s|\.<|\.:|\xA0)'
        return re.sub(tpl, self.fix_long, text, 0)

    def parseImages(self, parentparseImages):
        def wrapper(msg):
            if not self.active: return parentparseImages(msg)
            msg = self.DecorateUrls(msg)
            return parentparseImages(msg)
        return wrapper