# -*- coding: utf-8 -*-

import wx, re, urllib
import base
import common

max_lines = 5

class bbMultiline(base.Baselugin):
    def __init__(self,parent,modulename,active):
        base.Baselugin.__init__(self,parent,modulename,active)
        self.name = "BB Multiline"
        self.version = "v1.0"
        self.description = u"""Эмулятор многострочных сообщений ;)."""
        self.active = active
        parent.Worker.parseImages = self.parseImages(parent.Worker.parseImages)
        parent.Say = self.Say(parent.Say)


    def SetActive(self,active = True):
        self.active = active

    def Say(self, parentSay):
        def wrapper(txtVal):
            if not self.active: return parentSay(txtVal)
            txtVal = re.sub('\n','[br]',txtVal,0)
            return parentSay(txtVal)
        return wrapper

    def bbBR(self, msg):
        msg = re.sub('(?i)\[br\]', '<br>', msg, max_lines-1)
        return re.sub('(?i)\[br\]', ' ', msg, 0)

    def parseImages(self, parentparseImages):
        def wrapper(msg):
            if not self.active: return parentparseImages(msg)
            msg = self.bbBR(msg)
            return parentparseImages(msg)
        return wrapper