# -*- coding: utf-8 -*-
#Example2.py
#Пример плагина

import re,wx
import base
import common

class Example(base.Baselugin):
    def __init__(self,parent,modulename,active):
        base.Baselugin.__init__(self,parent,modulename,active)
        self.name = "Green easy"
        self.version = "1.0"
        self.description = """Add green copyright to 'easy' word %)."""
        self.active = active
        parent.ProcessNotyfyHandler = self.NotyfyHandler(parent.ProcessNotyfyHandler)

    def SetActive(self,active = True):
        self.active = active

    def NotyfyHandler(self, parentNotyfyHandler): #Тут плагин работает
        def wrapper(event):
            if not self.active: return parentNotyfyHandler(event)
            if (event.type == common.NOTIFY_CHAT_OK):
                if not event.attr1 is None:
                    event.attr1 = re.sub("([^\"])easy","\\1easy<font color=green>&copy;</font>",
                    event.attr1,0)
            return parentNotyfyHandler(event)
        return wrapper